Index: /trunk/java-client/corbaiface.idl
===================================================================
--- /trunk/java-client/corbaiface.idl	(revision 2248)
+++ /trunk/java-client/corbaiface.idl	(revision 2249)
@@ -6,10 +6,4 @@
 
 typedef sequence<string> stringSeq;
-
-//
-// Used to textual arguments backwards and forwards across
-// the interface. The encoding is 0 for full unicode character
-// data and undefined otherwise.
-//
 
 struct corbatext_t
@@ -17,5 +11,5 @@
   usString text;
   unsigned short encoding;
-  unsigned long long length;
+  unsigned long  length;
 };
 
@@ -23,9 +17,4 @@
 
 typedef corbatext_tarray corbatext_tset;
-
-//
-// A map of names to values. Names may occur twice. Used largely
-// for passing metadata around
-//
 
 struct corbatext_tmap
@@ -38,16 +27,8 @@
 
 enum corbaComError
-{ 
-  // There were no errors
-  corbaNoError, 
-  // The server could not authenticate the client or the 
-  // authentication indicated insufficient priviledges
+{ corbaNoError, 
   corbaAuthenticationFailure, 
-  // ??
   corbaProtocolError, 
-  // ??
   corbaConfigurationError, 
-  // The server is unable to provide service due to an
-  // unspecified system problem on the server side.
   corbaSystemProblem
 };
@@ -59,42 +40,25 @@
 struct corbaShortColInfo
 {
-  // the textual name of the collection
   corbatext_t name;
-  // the textual name of the server
   corbatext_t host;
-  // ???
-  long long   response;
+  long        response;
 };
 
 struct corbaColInfoResponse
 {
-  corbaShortColInfo   shoftInfo;
-  // the collection is public
-  boolean             isPublic;
-  // the collection is reliable
-  boolean             isBeta;
-  // the timestamp of the collection building
-  unsigned long long       buildDate;
-  // ???
-  corbatext_tarray    ccsCols;        // Added 05/04/2000
-  // ???
-  corbatext_tarray    languages;
-  // the number of documents in the collection
-  unsigned long long  numDocs;
-  // the number of words in the collection
-  unsigned long long  numWords;
-  // the number of bytes in the collection
-  unsigned long long  numBytes;
-  // the collection level metadata
+  corbaShortColInfo shoftInfo;
+  boolean           isPublic;
+  boolean           isBeta;
+  unsigned long     buildDate;
+  corbatext_tarray  ccsCols;        // Added 05/04/2000
+  corbatext_tarray  languages;
+  unsigned long     numDocs;
+  unsigned long     numWords;
+  unsigned long     numBytes;
   corbatext_tmap    collectionMeta;
-  // ???
   corbatext_tmap    format;
-  // ???
   corbatext_tmap    building;
-  // the domain for http request for associated files and images
   corbatext_t       httpdomain ;    // Added 27/07/2000
-  // the domain for prefix request for associated files and images
   corbatext_t       httpprefix;     // Added 27/07/2000
-  // the textual name of the receptionist
   corbatext_t       receptionist;
 };
@@ -106,9 +70,6 @@
 struct corbaDocRequest
 { 
-  // the document ID
   corbatext_t OID;
-  // the mine type the Doc should be in, or "" for any
   corbatext_t docType;
-  // ??
   corbatext_t docFormat;
 };
@@ -120,5 +81,4 @@
 struct corbaDocResponse
 { 
-  // the actual document
   corbatext_t doc;
 };
@@ -173,5 +133,5 @@
   corbaOptionValue_array filterOptions;
   corbatext_tarray       docSet;
-  long long                   filterResultOptions;
+  long                   filterResultOptions;
   corbatext_t            requestParams;
   corbatext_t            refParams;
@@ -183,5 +143,5 @@
 {
   corbatext_t      term;
-  long long        frequency;
+  long             frequency;
   corbatext_tarray matchTerms;
 };
@@ -194,6 +154,6 @@
   boolean          isRef;
   corbatext_tarray values;
-  long long             id;
-  long long             parentid; // dodge for avoiding pointers for the moment
+  long             id;
+  long             parentid; // dodge for avoiding pointers for the moment
 };
 
@@ -206,17 +166,17 @@
 };
 
-typedef sequence<long long> corbaDocFreq_array;
+typedef sequence<long> corbaDocFreq_array;
 
 struct corbaResultDocInfo
 {
   corbatext_t             OID;
-  long long                    resultNum;
-  long long                    ranking;
-  long long                    termsMatched;
-  long long                    phraseMatched;
+  long                    resultNum;
+  long                    ranking;
+  long                    termsMatched;
+  long                    phraseMatched;
   corbaDocFreq_array      docFreq;
   corbaMetadataInfo_map   metadata;
   corbatext_t             classifierMetadataType;    // Added 05/04/2000
-  long long                    classifierMetadataOffset;  // Added 05/04/2000
+  long                    classifierMetadataOffset;  // Added 05/04/2000
   corbaMetadataInfo_array metaparents;
 };
@@ -233,5 +193,5 @@
 struct corbaFilterResponse
 {
-  long long                     numDocs;
+  long                     numDocs;
   corbaIsApprox            isApprox;
   corbaTermInfo_array      termInfo;