Index: trunk/gsdl/macros/french.dm
===================================================================
--- trunk/gsdl/macros/french.dm	(revision 1790)
+++ trunk/gsdl/macros/french.dm	(revision 2299)
@@ -86,18 +86,12 @@
 _httpiconchomeof_ [l=fr] {_httpimg_/fr/chomeof.gif}
 _httpiconchomeon_ [l=fr] {_httpimg_/fr/chomeon.gif}
-_widthchomex_ [l=fr] {72}
-_heightchomex_ [l=fr] {20}
 
 ## "AIDE" ## top_nav_button ## chelp ##
 _httpiconchelpof_ [l=fr] {_httpimg_/fr/chelpof.gif}
 _httpiconchelpon_ [l=fr] {_httpimg_/fr/chelpon.gif}
-_widthchelpx_ [l=fr] {32}
-_heightchelpx_ [l=fr] {20}
 
 ## "PREFERENCES" ## top_nav_button ## cpref ##
 _httpiconcprefof_ [l=fr] {_httpimg_/fr/cprefof.gif}
 _httpiconcprefon_ [l=fr] {_httpimg_/fr/cprefon.gif}
-_widthcprefx_ [l=fr] {83}
-_heightcprefx_ [l=fr] {20}
 
 ## "aide" ## green_title ## h_help ##
@@ -111,5 +105,4 @@
 _httpicontauthon_ [l=fr] {_httpimg_/fr/tauthon.gif}
 _widthtauthx_ [l=fr] {100}
-_heighttauthx_ [l=fr] {17}
 
 ## "series" ## nav_bar_button ## tser ##
@@ -118,5 +111,4 @@
 _httpicontseron_ [l=fr] {_httpimg_/fr/tseron.gif}
 _widthtserx_ [l=fr] {87}
-_heighttserx_ [l=fr] {17}
 
 ## "dates" ## nav_bar_button ## tdate ##
@@ -125,5 +117,4 @@
 _httpicontdateon_ [l=fr] {_httpimg_/fr/tdateon.gif}
 _widthtdatex_ [l=fr] {87}
-_heighttdatex_ [l=fr] {17}
 
 ## "sujets" ## nav_bar_button ## tsubj ##
@@ -132,5 +123,4 @@
 _httpicontsubjof_ [l=fr] {_httpimg_/fr/tsubjof.gif}
 _widthtsubjx_ [l=fr] {87}
-_heighttsubjx_ [l=fr] {17}
 
 ## "organisation" ## nav_bar_button ## torg ##
@@ -139,5 +129,4 @@
 _httpicontorgof_ [l=fr] {_httpimg_/fr/torgof.gif}
 _widthtorgx_ [l=fr] {105}
-_heighttorgx_ [l=fr] {17}
 
 ## "comment faire" ## nav_bar_button ## thow ##
@@ -146,5 +135,4 @@
 _httpiconthowof_ [l=fr] {_httpimg_/fr/thowof.gif}
 _widththowx_ [l=fr] {122}
-_heightthowx_ [l=fr] {17}
 
 ## "theme" ## nav_bar_button ## ttopic ##
@@ -153,5 +141,4 @@
 _httpiconttopicof_ [l=fr] {_httpimg_/fr/ttopicof.gif}
 _widthttopicx_ [l=fr] {87}
-_heightttopicx_ [l=fr] {17}
 
 ## "naviguer" ## nav_bar_button ## tbrwse ##
@@ -160,5 +147,4 @@
 _httpicontbrwseof_ [l=fr] {_httpimg_/fr/tbrwseof.gif}
 _widthtbrwsex_ [l=fr] {87}
-_heighttbrwsex_ [l=fr] {17}
 
 ## "rechercher" ## nav_bar_button ## tsrch ##
@@ -167,5 +153,4 @@
 _httpicontsrchon_ [l=fr] {_httpimg_/fr/tsrchon.gif}
 _widthtsrchx_ [l=fr] {90}
-_heighttsrchx_ [l=fr] {17}
 
 ## "titres a-z" ## nav_bar_button ## ttitl ##
@@ -174,5 +159,4 @@
 _httpiconttitlon_ [l=fr] {_httpimg_/fr/ttitlon.gif}
 _widthttitlx_ [l=fr] {87}
-_heightttitlx_ [l=fr] {17}
 
 ## "personnes" ## nav_bar_button ## tpeop ##
@@ -181,6 +165,4 @@
 _httpicontpeopon_ [l=fr] {_httpimg/tpeopon.gif}
 _widthtpeopx_ [l=fr] {87}
-_heighttpeopx_ [l=fr] {17}
-
 
 
@@ -335,49 +317,32 @@
 _httpiconcontoff_ [l=fr] {_httpimg_/fr/contoff.gif}
 _httpiconconton_ [l=fr] {_httpimg_/fr/conton.gif}
-_widthcontx_ [l=fr] {72}
-_heightcontx_ [l=fr] {17}
 
 ## "ETENDRE LE TEXTE" ## document_button ## eallt ## 
 _httpiconealltof_ [l=fr] {_httpimg_/fr/ealltof.gif}
 _httpiconeallton_ [l=fr] {_httpimg_/fr/eallton.gif}
-_widthealltx_ [l=fr] {92}
-_heightealltx_ [l=fr] {30}
 
 ## "CONTRACT CONTENTS" ## document_button ## econc ##
 _httpiconeconcof_ [l=fr] {_httpimg_/fr/econcof.gif}
 _httpiconeconcon_ [l=fr] {_httpimg_/fr/econcon.gif}
-_widtheconcx_ [l=fr] {113}
-_heighteconcx_ [l=fr] {30}
 
 ## "DETACH" ## document_button ## edtch ##
 _httpiconedtchof_ [l=fr] {_httpimg_/fr/edtchof.gif}
 _httpiconedtchon_ [l=fr] {_httpimg_/fr/edtchon.gif}
-_widthedtchx_ [l=fr] {65}
-_heightedtchx_ [l=fr] {30}
 
 ## "ETENDRE LE CONTENU" ## document_button ## eexpc ##
 _httpiconeexpcof_ [l=fr] {_httpimg_/fr/eexpcof.gif}
 _httpiconeexpcon_ [l=fr] {_httpimg_/fr/eexpcon.gif}
-_widtheexpcx_ [l=fr] {110}
-_heighteexpcx_ [l=fr] {30}
 
 ## "CONTRACT TEXT" ## document_button ## etsec ##
 _httpiconetsecof_ [l=fr] {_httpimg_/fr/etsecof.gif}
 _httpiconetsecon_ [l=fr] {_httpimg_/fr/etsecon.gif}
-_widthetsecx_ [l=fr] {85}
-_heightetsecx_ [l=fr] {30}
 
 ## "METTRE EN EVIDENCE" ## document_button ## ehl ##
 _httpiconehlof_ [l=fr] {_httpimg_/fr/ehlof.gif}
 _httpiconehlon_ [l=fr] {_httpimg_/fr/ehlon.gif}
-_widthehlx_ [l=fr] {106}
-_heightehlx_ [l=fr] {30}
 
 ## "NE PAS METTRE EN EVIDENCE" ## document_button ## enhl ##
 _httpiconenhlof_ [l=fr] {_httpimg_/fr/enhlof.gif}
 _httpiconenhlon_ [l=fr] {_httpimg_/fr/enhlon.gif}
-_widthenhlx_ [l=fr] {142}
-_heightenhlx_ [l=fr] {30}
-
 
 