Index: /trunk/gsinstaller/DiskSpace.cpp
===================================================================
--- /trunk/gsinstaller/DiskSpace.cpp	(revision 2323)
+++ /trunk/gsinstaller/DiskSpace.cpp	(revision 2324)
@@ -21,5 +21,5 @@
 	if (!GetDiskFreeSpace(rootName, &sectorsPerCluster, &bytesPerSector,
 												&freeClusters, &totalClusters))
-	{ this->initialised = false;
+	{ this->initialised = FALSE;
     return;
 	}
@@ -37,5 +37,5 @@
 		proc 		= GetProcAddress(module, "GetDiskFreeSpaceEx");
 		if (proc == NULL)
-		{	this->initialised = true;
+		{	this->initialised = TRUE;
 			return;
 		}
@@ -46,9 +46,9 @@
 		//freeClusters = totalBytes;
 	}
-  this->initialised = true;
+  this->initialised = TRUE;
 	return;
 }
 
-bool DiskSpace::initialisedOk()
+BOOL DiskSpace::initialisedOk()
 {	return this->initialised;
 }
Index: /trunk/gsinstaller/DiskSpace.h
===================================================================
--- /trunk/gsinstaller/DiskSpace.h	(revision 2323)
+++ /trunk/gsinstaller/DiskSpace.h	(revision 2324)
@@ -8,5 +8,5 @@
   DWORD bytesPerSector;
   DWORD freeClusters;
-  bool	initialised;
+  BOOL	initialised;
 protected:
 public:
@@ -14,5 +14,5 @@
   int 					fileSpace(int fileSize);
   int 					fileClusters(int fileSize);
-  bool					initialisedOk();
+  BOOL					initialisedOk();
   unsigned long totalFreeSpace();
 };
Index: /trunk/gsinstaller/registry.cpp
===================================================================
--- /trunk/gsinstaller/registry.cpp	(revision 2323)
+++ /trunk/gsinstaller/registry.cpp	(revision 2324)
@@ -2,5 +2,5 @@
 #include <stdlib.h>
 
-bool registry_createkey(HKEY key, const char *name, PHKEY keyout)
+BOOL registry_createkey(HKEY key, const char *name, PHKEY keyout)
 { 
   LONG reply;
@@ -18,5 +18,5 @@
 }
 
-bool registry_openkey(HKEY key, const char *name, PHKEY keyout)
+BOOL registry_openkey(HKEY key, const char *name, PHKEY keyout)
 {
   LONG reply;
@@ -25,19 +25,19 @@
   if (reply != ERROR_SUCCESS)
     {
-      return false;
-    }
-  return true;
-}
-
-bool registry_deletekey(HKEY key, const char *name)
+      return FALSE;
+    }
+  return TRUE;
+}
+
+BOOL registry_deletekey(HKEY key, const char *name)
 {	
   if (RegDeleteKey(key, name) != ERROR_SUCCESS)
     {
-      return false;
-    }
-  return true;
-}
-
-bool registry_closekey(HKEY key)
+      return FALSE;
+    }
+  return TRUE;
+}
+
+BOOL registry_closekey(HKEY key)
 {
   LONG reply;
@@ -50,5 +50,5 @@
 }
 
-bool registry_keyExists(HKEY key, const char *name)
+BOOL registry_keyExists(HKEY key, const char *name)
 {
   HKEY local;
@@ -56,11 +56,11 @@
   if (!registry_openkey(key, name, &local))
   {
-    return false;
+    return FALSE;
   }
   registry_closekey(local);
-  return true;
-}
-
-bool registry_ensureKeyExists(HKEY key, const char *name)
+  return TRUE;
+}
+
+BOOL registry_ensureKeyExists(HKEY key, const char *name)
 { 
   HKEY local;
@@ -70,21 +70,21 @@
       if (!registry_createkey(key, name, &local))
   	{
-	  return false;
+	  return FALSE;
 	}
     }
   registry_closekey(local);
-  return true;
-}
-
-bool registry_deleteitem(HKEY key, const char *name)
+  return TRUE;
+}
+
+BOOL registry_deleteitem(HKEY key, const char *name)
 {
   if (RegDeleteValue(key, name) != ERROR_SUCCESS)
     {
-      return false;
-    }
-  return true;
-}
-
-bool registry_setstring(HKEY key, const char *name, const char *value)
+      return FALSE;
+    }
+  return TRUE;
+}
+
+BOOL registry_setstring(HKEY key, const char *name, const char *value)
 {
   LONG reply;
@@ -93,10 +93,10 @@
   if (reply != ERROR_SUCCESS)
   {
-    return false;
-  }
-  return true;
-}
-
-bool registry_setlong(HKEY key, char *name, LONG value)
+    return FALSE;
+  }
+  return TRUE;
+}
+
+BOOL registry_setlong(HKEY key, char *name, LONG value)
 {
   LONG 	reply;
@@ -112,5 +112,5 @@
 }
 
-bool registry_setblock(HKEY key, char *name, char *data, int size)
+BOOL registry_setblock(HKEY key, char *name, char *data, int size)
 {
   LONG 	reply;
@@ -125,10 +125,10 @@
 }
 
-bool registry_setint(HKEY key, char *name, int value)
+BOOL registry_setint(HKEY key, char *name, int value)
 { 
   return registry_setlong(key, name, (LONG) value);
 }
 
-bool registry_getstring(HKEY key, char *name, char **string)
+BOOL registry_getstring(HKEY key, char *name, char **string)
 {
   LONG reply;
@@ -164,5 +164,5 @@
 }
 
-bool registry_getint(HKEY key, char *name, int *out)
+BOOL registry_getint(HKEY key, char *name, int *out)
 {
   DWORD type;
@@ -178,5 +178,5 @@
 }
 
-bool registry_getlong(HKEY key, char *name, LONG *out)
+BOOL registry_getlong(HKEY key, char *name, LONG *out)
 {
   DWORD type;
@@ -212,5 +212,5 @@
 }
 
-bool registry_fetchlong(char *keystr, LONG *lptr)
+BOOL registry_fetchlong(char *keystr, LONG *lptr)
 {
   HKEY key;
@@ -231,5 +231,5 @@
 }
 
-bool registry_fetchblock(char *keystr, char *data, int size)
+BOOL registry_fetchblock(char *keystr, char *data, int size)
 {
   HKEY key;
@@ -252,5 +252,5 @@
 }
 
-bool registry_storelong(char *keystr, LONG value)
+BOOL registry_storelong(char *keystr, LONG value)
 {
   HKEY key;
@@ -271,5 +271,5 @@
 }
 
-bool registry_storeint(char *keystr, int value)
+BOOL registry_storeint(char *keystr, int value)
 { 
   HKEY key;
@@ -290,5 +290,5 @@
 }
 
-bool registry_storeblock(char *keystr, char *data, int size)
+BOOL registry_storeblock(char *keystr, char *data, int size)
 {
   HKEY key;
@@ -309,5 +309,5 @@
 }
 
-bool registry_storestring(char *keystr, char *value)
+BOOL registry_storestring(char *keystr, char *value)
 {
   HKEY key;
Index: /trunk/gsinstaller/registry.h
===================================================================
--- /trunk/gsinstaller/registry.h	(revision 2323)
+++ /trunk/gsinstaller/registry.h	(revision 2324)
@@ -3,15 +3,15 @@
 #include <windows.h>
 
-bool registry_openkey(HKEY key, const char *name, PHKEY keyout);
-bool registry_storeblock(char *name, char *data, int size);
-bool registry_fetchblock(char *name, char *data, int size);
-bool registry_getstring(HKEY key, char *name, char **string);
-bool registry_setstring(HKEY key, const char *name, const char *string);
-bool registry_deleteitem(HKEY key, const char *name);
-bool registry_createkey(HKEY key, const char *name, PHKEY keyout);
-bool registry_deletekey(HKEY key, const char *name);
-bool registry_closekey(HKEY key);
-bool registry_keyExists(HKEY key, const char *name);
-bool registry_ensureKeyExists(HKEY key, const char *name);
+BOOL registry_openkey(HKEY key, const char *name, PHKEY keyout);
+BOOL registry_storeblock(char *name, char *data, int size);
+BOOL registry_fetchblock(char *name, char *data, int size);
+BOOL registry_getstring(HKEY key, char *name, char **string);
+BOOL registry_setstring(HKEY key, const char *name, const char *string);
+BOOL registry_deleteitem(HKEY key, const char *name);
+BOOL registry_createkey(HKEY key, const char *name, PHKEY keyout);
+BOOL registry_deletekey(HKEY key, const char *name);
+BOOL registry_closekey(HKEY key);
+BOOL registry_keyExists(HKEY key, const char *name);
+BOOL registry_ensureKeyExists(HKEY key, const char *name);
 #endif
 